<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2007 Georg Ringer (just2b) <http://www.just2b.com>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(PATH_tslib.'class.tslib_pibase.php');


/**
 * Plugin 'rgtabs' for the 'rgtabs' extension.
 *
 * @author	Georg Ringer (just2b) <http://www.just2b.com>
 * @package	TYPO3
 * @subpackage	tx_rgtabs
 */
class tx_rgtabs_pi1 extends tslib_pibase {
	var $prefixId      = 'tx_rgtabs_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_rgtabs_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey        = 'rgtabs';	// The extension key.
	var $pi_checkCHash = true;

	function init($conf)	{
    $this->conf = $conf; // Storing configuration as a member var
		$this->pi_loadLL(); // Loading language-labels
		$this->pi_setPiVarDefaults(); // Set default piVars from TS
		$this->pi_initPIflexForm(); // Init FlexForm configuration for plugin
		
		// Template code
		$this->templateCode = $this->cObj->fileResource($this->conf['templateFile']);

		// configuration flexforms
    // get the records: 1st Flexforms, 2nd TS, 3rd override by stdwrap
    $records =  $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'records', 'sDEF') ? $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'records', 'sDEF') : $this->conf['records'];
    $this->cObj->data['tx_rgtabsRecords']=$records;   
    $records = $this->cObj->stdWrap($records,$this->conf['records.']);
    $this->config['records'] = trim($records," \t\,"); # some trimming cause if the value comes from TS, there is a ',' too much
    
  	// get the title
    $titleOverride =  $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'text', 'sDEF') ? $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'text', 'sDEF') : $this->conf['titleOverride'];
		
		// get the rest of the fields from flexforms
    $this->config['titleOverride'] = explode("\n",$titleOverride);
		$this->config['breaks'] =  $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'breaks', 'sDEF') ? $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'breaks', 'sDEF') : $this->conf['breaks'];
		$this->config['ajax'] =  intval($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'ajax', 'sDEF')) ? ($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'ajax', 'sDEF')) : intval($this->conf['ajax']);		
		$this->config['childelement'] =  intval($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'childelement', 'sDEF'));
		$this->config['showAsFirst'] =  intval($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'showfirst', 'sDEF')) ? ($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'showfirst', 'sDEF')) : intval($this->conf['showfirst']);
  }	
	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	function main($content,$conf)	{
	  $this->init($conf);
		$this->conf=$conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		
		// foolproof if no static TS is inserted
    if ($this->conf['isLoaded']!='ok') {
      return $this->pi_getLL('errorIncludeStatic');
    // if no CEs are there, no output because empty tabs are ugly
    } elseif ($this->config['records']=='') {
      return '';
    }

		// unique id = uid of CE
    $id = $this->cObj->data['uid'];
    
    // build the correct array with CE breaks 
    $breakList = explode('|',$this->config['breaks']);    
    $idList = explode(',',$this->config['records']);

    $t = Array();
    $tcount = 0;
    $count=0;
    $i=0;

    // calculation just if there are breaks set. If not. every CE is in a single tab
    if ($this->config['breaks']!='') {
      // some array calculation
      foreach ($breakList as $key=>$value) {
      	$count = trim($value)+$i;
        for ($i;$i<$count ;$i++ ) {
          if ($idList)  $t[$tcount][] =array_shift($idList); 
        }
        $tcount++;
      }
      
      foreach ($idList as $key=>$value) {
      	$t[$tcount-1][] = $value;
      }
      
    // if no break-string, just every CE in an own tab
    } else {
      foreach ($idList as $key=>$value) {
      	$t[$key][] = $value;
      }
    }

    // get all the neccessary js
    $this->getJs($id,count($t));

    // begin with the real output
    $content .= $this->beginGallery($id);
    
    // add every tab
    foreach ($t as $key=>$singleTab) {
      $tabIds = implode(',',$singleTab);
      $content.= $this->getTab($t,$tabIds,$this->config['titleOverride'][$key]); 
    }

    
    // end gallery
    $content .= $this->endGallery();
    
		return $this->pi_wrapInBaseClass($content);
	}
	
	/**
	 * Get the single tab, with and without ajax
	 *
	 * @param	int    $key: key of the global tab array
	 * @param	string $ids: All CEs in this tab
	 * @param	string $title: Title of the tab 	 
	 * @return	The single tab
	 */
  function getTab ($key,$ids,$title) {
    $tmpIds = explode(',',$ids);
    
    // if no title via flexform > first of the CEs
    if ($title=='') { 
      if ($tmpIds[0]) {
        $res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('header,uid','tt_content','uid ='.$tmpIds[0].' AND deleted = 0 AND hidden = 0');
        $row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
        $title = ($row['header']);
        $this->cObj->data['tx_rgtabsTitle']=$row['uid'];
      }
    } else {     
      $this->cObj->data['tx_rgtabsTitle']=$tmpIds[0];
    }

    $title = $this->cObj->stdWrap($title,$this->conf['title.']);
    
    /*
     * if no ajax used, all the CEs need to be loaded    
     */     
    if ($this->config['ajax']==0) {
      // if this is a childelement, use h6 instead of h4
      if ($this->config['childelement']==1) {
        $tab .= '<h6>'.$title.'</h6>';
      } else {
        $tab .= '<h4>'.$title.'</h4>';
      }
      
      // get the CEs
      $conf = array('tables' => 'tt_content','source' => $ids,'dontCheckPid' => 1);
      $tab .= '<div>'.$this->cObj->RECORDS($conf).'</div>';

    /*
     * if ajax is used, just links to the content elements are needed    
     */     
    } else {        
      $tab = '<li><a href="index.php?id='.$GLOBALS["TSFE"]->id.'&type=543&tab='.$ids.'">'.$title.'</a></li>';
    }
    
    return $tab;
  }


 
	/**
	 * Necessary html code to begin the tabs
	 *
	 * @param	int    $id: unique id
	 * @return	just some html
	 */  
  function beginGallery($id) {
    if ($this->config['ajax']==1) return '<div  id="rgtabs'.$id.'"><ul>';
    else return '<div  id="rgtabs'.$id.'">';
  }

	/**
	 * Necessary html code to end the tabs
	 *
	 * @return	just some html
	 */   
  function endGallery() {
    if ($this->config['ajax']==1) return '</ul></div>';
    else return '</div>';
  }

	/**
	 * Necessary js code for the  tabs
	 *
	 * @param	int    $id: unique id
	 * @param	int    $count: number of tabs
	 * @return	void
	 */	
  function getJs ($id,$count) { 

	 if (t3lib_extMgm::isLoaded('t3mootools'))    {
	   require_once(t3lib_extMgm::extPath('t3mootools').'class.tx_t3mootools.php');
	 } 	 
	 if (defined('T3MOOTOOLS')) {
	 	tx_t3mootools::addMooJS();
	 } else {
    $tmpJS =  ($this->conf['pathToMootools']) ? '<script type="text/javascript" src="'.$this->getPath($this->conf['pathToMootools']).'"></script>' : '';
	 }  
  
    // all the static JS
    $tmpJS .= ($this->conf['pathToJS']) ? '<script type="text/javascript" src="'.$this->getPath($this->conf['pathToJS']).'"></script>' : '';
    $tmpJS .= ($this->conf['pathToCSS']) ? '<link rel="stylesheet" href="'.$this->getPath($this->conf['pathToCSS']).'" type="text/css" media="screen" />' : '';
    $GLOBALS['TSFE']->additionalHeaderData['rgtabs'] = $tmpJS;

    // all the dynamic JS
    if ($this->config['ajax']==1) {
      $js = "entrySelector: 'li a',
				ajaxOptions: {
					method: 'get'
				}";
    } else {
      $js = "entrySelector: 'h4'";
    }
    
    // if the CE is a childelement,
    if ($this->config['childelement']==1) { 
      $js = "entrySelector: 'h6'";
      if ($this->config['ajax']==1) {
        $js = "entrySelector: 'li a',
  				ajaxOptions: {
  					method: 'get'
  				}";
      }
    }   
    
    // open another than the 1st tab if the given tab is available
    if ($this->config['showAsFirst']>1 && $count>= $this->config['showAsFirst']) {
      $js.= ', show:'.($this->config['showAsFirst']-1);
    }
    
    // get a delay
    if (intval($this->conf['delay'])>0) {
      $js.= ', delay:'.intval($this->conf['delay']);
    }
    
    // save JS to the header part of the page
    $GLOBALS["TSFE"]->additionalJavaScript["rgtabs"] .= "
  		window.addEvent('domready', function() {
  			var tabs$id = new SimpleTabs($('rgtabs$id'), {
          $js
  			});
  		});
    "; 
  }	

	/**
	 * The xml method of the PlugIn. Used for the ajax connection to get the tabs
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The tabs
	 */
  function xmlFunc($content,$conf)	{		
    $this->init($conf);
    $id = t3lib_div::GPvar('tab');
    $pageId = $GLOBALS['TSFE']->id;


    $securityCheck = 1;

    
    
    if ($securityCheck>0) {
      $conf = array('tables' => 'tt_content','source' => $id,'dontCheckPid' => 1);    
      $xml .= '<tab>'.$this->cObj->RECORDS($conf).'</tab>';

    } else {
      $xml .= '<tab>Security failed</tab>';
    }
    

    

    return $xml;

  }	


	/**
	 * Gets the path to a file, needed to translate the 'EXT:extkey' into the real path
	 *
	 * @param	string  $path: Path to the file
	 * @return the real path
	 */
  function getPath($path) {
    if (substr($path,0,4)=='EXT:') {
      $keyEndPos = strpos($path, '/', 6);
      $key = substr($path,4,$keyEndPos-4);
      $keyPath = t3lib_extMgm::siteRelpath($key);
      $newPath = $keyPath.substr($path,$keyEndPos+1);
      return $newPath;
    }	else {
      return $path;
    }
  } # end getPath  
}


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/rgtabs/pi1/class.tx_rgtabs_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/rgtabs/pi1/class.tx_rgtabs_pi1.php']);
}

?>